



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CentOS 7 安装php5.6,Nginx,Memcached环境及配置</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CentOS 7 安装php5.6,Nginx,Memcached环境及配置</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 23:43:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>安装php5.6版本以后不再需要安装Zend Guard，而是用yum命令安装php-opcache及php-pecl-apcu就可以有效的提高php执行速度。</p>
<p>1. 配置yum源</p>
<p>事先确认yum源的链接是不是有效的。</p>
<p>yum install epel-release</p>
<p>rpm -ivh http://rpms.famillecollet.com/enterprise/remi-release-7.rpm</p>
<p>3. 确认安装的php版本</p>
<p>yum list --enablerepo=remi --enablerepo=remi-php56 | grep php</p>
<p>4. 安装php5.6</p>
<p>yum install --enablerepo=remi --enablerepo=remi-php56&nbsp;php php-opcache php-pecl-apcu php-devel php-mbstring php-mcrypt php-mysqlnd php-phpunit-PHPUnit&nbsp;php-pecl-xdebug php-pecl-xhprof php-pdo php-pear php-fpm php-cli php-xml php-bcmath php-process php-gd php-common</p>
<p>php-opcache及php-pecl-apcu会有效的提高php执行速度</p>
<p>4. 确认php版本</p>
<p># php -v<br />PHP 5.6.6 (cli) (built: Feb 19 2015 10:19:37)<br />Copyright (c) 1997-2015 The PHP Group<br />Zend Engine v2.6.0, Copyright (c) 1998-2015 Zend Technologies<br />&nbsp;&nbsp;&nbsp; with Zend OPcache v7.0.4-dev, Copyright (c) 1999-2015, by Zend Technologies<br />&nbsp;&nbsp;&nbsp; with Xdebug v2.3.1, Copyright (c) 2002-2015, by Derick Rethans</p>
<p>测试PHP-fpm服务是否正常</p>
<p>#systemctl start &nbsp;php-fpm.service</p>
<p>使用：#netstat -an查看9000端口有没有在监听</p>
<div>
<pre class="prettyprint linenums">systemctl start nginx.service              #启动nginx服务<br />
systemctl enable nginx.service             #设置开机自启动<br />
systemctl disable nginx.service            #停止开机自启动<br />
systemctl status nginx.service             #查看服务当前状态<br />
systemctl restart nginx.service　          #重新启动服务<br />
systemctl list-units --type=service        #查看所有已启动的服</pre>
<pre class="prettyprint linenums"><code>systemctl enable php-fpm.service</code></pre>
<pre class="prettyprint linenums">&nbsp;</pre>
</div>
<p>Mysql配置文件my.cnf路径：/etc/my.cnf</p>
<p>Nginx配置文件nginx.conf路径：/etc/nginx/nginx.conf</p>
<p>PHP配置文件php.ini路径： /etc/php.ini</p>
<p>php-fpm配置文件php-fpm.conf路径：/etc/php-fpm.conf</p>
<p><strong>安装NGINX</strong></p>
<p><strong>1.添加资源</strong></p>
<p>添加CentOS 7 Nginx yum资源库,打开终端,使用以下命令(没有换行):</p>
<div>
<pre class="prettyprint linenums">rpm -Uvh http://nginx.org/packages/centos/7/noarch/RPMS/nginx-release-centos-7-0.el7.ngx.noarch.rpm</pre>
</div>
<p>2.安装Nginx</p>
<p>在你的CentOS 7 服务器中使用yum命令从Nginx源服务器中获取来安装Nginx：</p>
<p>这里有一个需要注意的地方，尽量不要用网上的下载源码包然后再传到服务器上的方式进行安装，因为nginx已经不算是简单的Linux了，做了很多扩展，这个时候如果你用源码包安装会出现各种各样的问题，尽量用已经封装好的rpm\yum进行安装</p>
<div>
<pre class="prettyprint linenums"> yum install -y nginx</pre>
</div>
<p>Nginx将完成安装在你的CentOS 7 服务器中。</p>
<p><strong>3.启动Nginx</strong></p>
<p>刚安装的Nginx不会自行启动。运行Nginx:</p>
<div>
<pre class="prettyprint linenums">systemctl start nginx.service</pre>
</div>
<p>如果一切进展顺利的话，现在你可以通过你的域名或IP来访问你的Web页面来预览一下Nginx的默认页面</p>
<blockquote><p>当然，这里一般很可能会无法访问的。</p></blockquote>
<p>我们先不急于解决我们的问题，先看看nginx的基本配置：</p>
<div>
<pre class="prettyprint linenums">网站文件存放默认目录

/usr/share/nginx/html<br />
网站默认站点配置

/etc/nginx/conf.d/default.conf<br />
自定义Nginx站点配置文件存放目录,自己在这里也可以定义别的名字的.conf，这个的作用以后再说。

/etc/nginx/conf.d/<br />
Nginx全局配置

/etc/nginx/nginx.conf<br />
在这里你可以改变设置用户运行Nginx守护程序进程一样,和工作进程的数量得到了Nginx正在运行,等等。</pre>
</div>
<p>好了，这个时候我们再来看看可能遇到的问题：无法在公网访问。</p>
<p>这个时候首先看看配置文件default.conf对不对，一个正确的例子：&nbsp;<br />(域名要先进行解析到响应的IP)</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen       80;<br />
    server_name  nginx.310058.cn;

    #charset koi8-r;<br />
    #access_log  /var/log/nginx/log/host.access.log  main;

    location / {<br />
        root   /usr/share/nginx/html;<br />
        index  index.html index.htm;<br />
    }

    #error_page  404              /404.html;

    # redirect server error pages to the static page /50x.html<br />
    #<br />
    error_page   500 502 503 504  /50x.html;<br />
    location = /50x.html {<br />
        root   /usr/share/nginx/html;<br />
    }

    # proxy the PHP scripts to Apache listening on 127.0.0.1:80<br />
    #<br />
    #location ~ \.php$ {<br />
    #    proxy_pass   http://127.0.0.1;<br />
    #}

    # pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000<br />
    #<br />
    #location ~ \.php$ {<br />
    #    root           html;<br />
    #    fastcgi_pass   127.0.0.1:9000;<br />
    #    fastcgi_index  index.php;<br />
    #    fastcgi_param  SCRIPT_FILENAME  /scripts$fastcgi_script_name;<br />
    #    include        fastcgi_params;<br />
    #}

    # deny access to .htaccess files, if Apache's document root<br />
    # concurs with nginx's one<br />
    #<br />
    #location ~ /\.ht {<br />
    #    deny  all;<br />
    #}<br />
}</pre>
</div>
<p>我的配置文件为（可正常运行）：</p>
<div>
<pre class="prettyprint linenums"># nano /etc/nginx/conf.d/default.conf                                                             

server {<br />
    listen       80;<br />
    server_name dev1.mydomain.com.cn;

    #charset koi8-r;<br />
    #access_log  /var/log/nginx/host.access.log  main;

    location / {<br />
        root   /usr/share/nginx/html;<br />
        index  index.html index.htm index.php;<br />
    }

    #error_page  404              /404.html;

    # redirect server error pages to the static page /50x.html<br />
    #<br />
    error_page   500 502 503 504  /50x.html;<br />
    location = /50x.html {<br />
        root   /usr/share/nginx/html;<br />
    }

    # proxy the PHP scripts to Apache listening on 127.0.0.1:80<br />
    #<br />
    #location ~ \.php$ {<br />
    #    proxy_pass   http://127.0.0.1;<br />
    #}

    # pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000<br />
    #<br />
    location ~ \.php$ {<br />
        root           html;<br />
        fastcgi_pass   127.0.0.1:9000;<br />
        fastcgi_index  index.php;<br />
        fastcgi_param  SCRIPT_FILENAME  /usr/share/nginx/html$fastcgi_script_name;<br />
        include        fastcgi_params;<br />
    }

    # deny access to .htaccess files, if Apache's document root<br />
    # concurs with nginx's one<br />
    #<br />
    #location ~ /\.ht {<br />
    #    deny  all;<br />
    #}<br />
}</pre>
</div>
<p>确定文件没问题了，看看这个时候是不是开启了nginx进程：</p>
<div>
<pre class="prettyprint linenums">ps -ef | grep nginx</pre>
</div>
<p>应该会输出一个或者多个进程，如果没有的话就开启或者重启试试看。</p>
<p>这个时候接下来再试试在服务器上：</p>
<div>
<pre class="prettyprint linenums">ping  115.29.102.81<br />
telnet 115.29.102.81 80<br />
wget nginx.310058.cn</pre>
</div>
<p>如果有的命令没有就直接yum安装下:</p>
<div>
<pre class="prettyprint linenums">yum -y install telnet</pre>
</div>
<p>如果都可以的话，之后在本机尝试以上三行。如果没有命令也要安装下：</p>
<div>
<pre class="prettyprint linenums">brew install wget</pre>
</div>
<p>发现很可能本机telnet不通，而服务器telnet通。&nbsp;<br />这个时候就是<strong>防火墙</strong>的问题。</p>
<h4>centos7.2防火墙</h4>
<p>由于centos 7版本以后默认使用firewalld后，网上关于iptables的设置方法已经不管用了，所以根本就别想用配置iptables做啥，根本没用。</p>
<p>查看下防火墙状态：</p>
<div>
<pre class="prettyprint linenums">[root@iZ28dcsp7egZ conf.d]# systemctl status firewalld<br />
● firewalld.service - firewalld - dynamic firewall daemon<br />
   Loaded: loaded (/usr/lib/systemd/system/firewalld.service; enabled; vendor preset: enabled)<br />
   Active: active (running) since Wed 2016-08-03 12:06:44 CST; 2h 49min ago<br />
 Main PID: 424 (firewalld)<br />
   CGroup: /system.slice/firewalld.service<br />
           └─424 /usr/bin/python -Es /usr/sbin/firewalld --nofork --nopid

Aug 03 12:06:41 iZ28dcsp7egZ systemd[1]: Starting firewalld - dynamic firewall daemon...<br />
Aug 03 12:06:44 iZ28dcsp7egZ systemd[1]: Started firewalld - dynamic firewall daemon.</pre>
</div>
<p>增加80端口的权限：</p>
<div>
<pre class="prettyprint linenums">firewall-cmd --zone=public --add-port=80/tcp --permanent  </pre>
</div>
<p>别忘了更新防火墙的配置：</p>
<div>
<pre class="prettyprint linenums">firewall-cmd --reload</pre>
</div>
<p>这个时候再<code>restart nginx.service</code>&nbsp;一下就会发现应该好了。</p>
<p>nginx 停止：</p>
<div>
<pre class="prettyprint linenums">service nginx restart<br />
也可以重启nginx

kill -QUIT 进程号<br />
#从容停止

kill -TERM 进程号<br />
#或者<br />
kill -INT 进程号<br />
#快速停止

p-kill -9 nginx<br />
强制停止

nginx -t<br />
#验证配置文件 前提是进入相应的配置的目录（自己实际测试的时候发现没有进入相应的配置目录也是可以的）

nginx -s reload<br />
#重启

kill -HUP 进程号<br />
#重启的另外一种方式</pre>
</div>
<p>官方文档地址：&nbsp;<br /><a href="https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Security_Guide/sec-Using_Firewalls.html#sec-Introduction_to_firewalld" rel="external nofollow noreferrer">https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Security_Guide/sec-Using_Firewalls.html#sec-Introduction_to_firewalld</a></p>
<p>附1:一个简单的负载均衡的实现:&nbsp;<br />weight默认是1，自己也可以更改。</p>
<p>附2:防火墙基本学习：</p>
<div>
<pre class="prettyprint linenums">1、firewalld简介<br />
firewalld是centos7的一大特性，最大的好处有两个：支持动态更新，不用重启服务；第二个就是加入了防火墙的&ldquo;zone&rdquo;概念

firewalld有图形界面和工具界面，由于我在服务器上使用，图形界面请参照官方文档，本文以字符界面做介绍

firewalld的字符界面管理工具是 firewall-cmd 

firewalld默认配置文件有两个：/usr/lib/firewalld/ （系统配置，尽量不要修改）和 /etc/firewalld/ （用户配置地址）

zone概念：<br />
硬件防火墙默认一般有三个区，firewalld引入这一概念系统默认存在以下区域（根据文档自己理解，如果有误请指正）：<br />
drop：默认丢弃所有包<br />
block：拒绝所有外部连接，允许内部发起的连接<br />
public：指定外部连接可以进入<br />
external：这个不太明白，功能上和上面相同，允许指定的外部连接<br />
dmz：和硬件防火墙一样，受限制的公共连接可以进入<br />
work：工作区，概念和workgoup一样，也是指定的外部连接允许<br />
home：类似家庭组<br />
internal：信任所有连接<br />
对防火墙不算太熟悉，还没想明白public、external、dmz、work、home从功能上都需要自定义允许连接，具体使用上的区别还需高人指点

2、安装firewalld<br />
root执行 # yum install firewalld firewall-config

3、运行、停止、禁用firewalld<br />
启动：# systemctl start  firewalld<br />
查看状态：# systemctl status firewalld 或者 firewall-cmd --state<br />
停止：# systemctl disable firewalld<br />
禁用：# systemctl stop firewalld

4、配置firewalld<br />
查看版本：$ firewall-cmd --version<br />
查看帮助：$ firewall-cmd --help<br />
查看设置：<br />
                显示状态：$ firewall-cmd --state<br />
                查看区域信息: $ firewall-cmd --get-active-zones<br />
                查看指定接口所属区域：$ firewall-cmd --get-zone-of-interface=eth0<br />
拒绝所有包：# firewall-cmd --panic-on<br />
取消拒绝状态：# firewall-cmd --panic-off<br />
查看是否拒绝：$ firewall-cmd --query-panic

更新防火墙规则：# firewall-cmd --reload<br />
                            # firewall-cmd --complete-reload<br />
    两者的区别就是第一个无需断开连接，就是firewalld特性之一动态添加规则，第二个需要断开连接，类似重启服务

将接口添加到区域，默认接口都在public<br />
# firewall-cmd --zone=public --add-interface=eth0<br />
永久生效再加上 --permanent 然后reload防火墙

设置默认接口区域<br />
# firewall-cmd --set-default-zone=public<br />
立即生效无需重启

打开端口（貌似这个才最常用）<br />
查看所有打开的端口：<br />
# firewall-cmd --zone=dmz --list-ports<br />
加入一个端口到区域：<br />
# firewall-cmd --zone=dmz --add-port=8080/tcp<br />
若要永久生效方法同上

打开一个服务，类似于将端口可视化，服务需要在配置文件中添加，/etc/firewalld 目录下有services文件夹，这个不详细说了，详情参考文档<br />
# firewall-cmd --zone=work --add-service=smtp

移除服务<br />
# firewall-cmd --zone=work --remove-service=smtp

还有端口转发功能、自定义复杂规则功能、lockdown，由于还没用到，以后再学习</pre>
</div>
<p>安装vsftpd</p>
<p>首先用命令检查VSFTP是否已经安装</p>
<div>
<pre class="prettyprint linenums">chkconfig --list | grep vsftpd</pre>
</div>
<p>接着使用<strong>yum</strong>命令直接安装</p>
<div>
<pre class="prettyprint linenums">yum  install &ndash;y vsftpd</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1nd59.html">centos7的网络设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwj7wy8.html">liunx常用的命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j15dg9.html">怎样操作WebAPI接口&lpar;显示数据&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390p4jn8.html">CoreData数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdl0378.html">【BZOJ1003】【ZJOI2006】物流运输</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21p3x8.html">Team Queue &lpar;uva540 队列模拟&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnoz6k9.html">一个方法告诉你as3的removeChild性能有多烂</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyz06m9.html">MSCRM 迁移 数据库 服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmekxe9.html">数据库性能优化：SQL索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0dxy4q.html">HDU 4565 So Easy&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxonjq.html">sunlime操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z65229.html">【HDOJ】1525 Euclid&amp;&num;39&semi;s Game</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vrdxq.html">Linux 高性能server编程&mdash;&mdash;高级I&sol;O函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwwxz9.html">ASP&period;NET MVC 文件上传和路径处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/950dmrv8.html">Java 异常处理笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxoojq.html">腾讯Web工程师的前端书单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4d039.html">MyCat 启蒙：分布式系统的数据库架构演变</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zox033q.html">ImageMagick命令行工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14w7eq.html">利用nginx搭建小型的文件服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1v1jlq.html">NOIP 提高组 2014 联合权值&lpar;图论？？？&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwljwyr9.html">Lua的文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnjgvgq.html">ExtJS 4&period;2 教程-04：数据模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ez2ex9.html">nginx 代理ssh</a>
			</li>
						<li><a href="https://www.batexi.com/a/902m4yjq.html">Material Designer的低版本兼容实现（八）&mdash;&mdash; Flat Button</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1jw2e9.html">FrameLayout和handle实现霓虹灯效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emyr2x9.html">Java工程师成神之路~（2018修订版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4j2wlq.html">Spring MVC 返回类型为字符串时&comma; 返回中文变成&amp;quot&semi;&quest;&amp;quot&semi;处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/963pkly9.html">go语言之进阶篇定时器重置</a>
			</li>
						<li><a href="https://www.batexi.com/a/902m01mq.html">iOS开发-UIActionSheet简单介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve1p7x9.html">WebService入门Demo</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
